Project authorization EnabledModule N+1 queries
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 2.4.0   

Resolution: Fixed Affected version:  

Description

There's a problem with project authorization that causes N+1 queries (one per project in Projects Projects).

In ApplicationController#authorize redmine checks authorization on Herve Harster or Projects Projects. This triggers the code in

Project#allowed_permissions which calls enabled_modules.pluck(:name).

The problem here is that pluck circumvents preloading, so no matter wether we do @projects =

Project.includes(:enabled_modules).where(conditions) in a controller, it will still trigger one extra query per project.

Given that the EnableModule model is tiny, this could be prevented by using enabled_modules.map(&:name) instead.

Associated revisions

Revision 12228 - 2013-10-20 18:04 - Jean-Philippe Lang

Avoid a query if enabled_modules association is already loaded (#15058).

History

#1 - 2013-10-20 18:05 - Jean-Philippe Lang

- Category changed from Database to Code cleanup/refactoring

- Status changed from New to Closed

- Resolution set to Fixed

Fixed in r12228, #pluck won't be called is the association is preloaded.

#2 - 2013-10-20 18:05 - Jean-Philippe Lang

- Target version set to 2.4.0

#3 - 2013-10-21 00:20 - Felix Bünemann

Nice solution, I didn't know about loaded? until now.
